OSDN Git Service

* fixincludes (sys/spinlock.h): change references of
[pf3gnuchains/gcc-fork.git] / gcc / fixincludes
1 #! /bin/sh
2 # Install modified versions of certain ANSI-incompatible system header files
3 # which are fixed to work correctly with ANSI C
4 # and placed in a directory that GNU C will search.
5
6 # See README-fixinc for more information.
7
8 # Command to run gcc.
9 GCCCMD=${4-${GCCCMD-gcc}}
10
11 # Directory where gcc sources (and sometimes special include files) live.
12 # fixincludes doesn't use this, but fixinc.svr4 does, and I want to make
13 # sure somebody doesn't try to use arg3 for something incompatible. -- gumby
14 SRCDIR=${3-${SRCDIR-.}}
15
16 # Directory containing the original header files.
17 # (This was named INCLUDES, but that conflicts with a name in Makefile.in.)
18 INPUT=${2-${INPUT-/usr/include}}
19
20 # Directory in which to store the results.
21 LIB=${1?"fixincludes: output directory not specified"}
22
23 # Define PWDCMD as a command to use to get the working dir
24 # in the form that we want.
25 PWDCMD=pwd
26 case "`pwd`" in
27 //*)
28         # On an Apollo, discard everything before `/usr'.
29         PWDCMD="eval pwd | sed -e 's,.*/usr/,/usr/,'"
30         ;;
31 esac
32
33 # Original directory.
34 ORIGDIR=`${PWDCMD}`
35
36 # Make sure it exists.
37 if [ ! -d $LIB ]; then
38   mkdir $LIB || exit 1
39 fi
40
41 # Make LIB absolute only if needed to avoid problems with the amd.
42 case $LIB in
43 /*)
44         ;;
45 *)
46         cd $LIB; LIB=`${PWDCMD}`
47         ;;
48 esac
49
50 # Make SRCDIR absolute only if needed to avoid problems with the amd.
51 cd $ORIGDIR
52 case $SRCDIR in
53 /*)
54         ;;
55 *)
56         cd $SRCDIR; SRCDIR=`${PWDCMD}`
57         ;;
58 esac
59
60 # Fail if no arg to specify a directory for the output.
61 if [ x$1 = x ]
62 then echo fixincludes: no output directory specified
63 exit 1
64 fi
65
66 echo Building fixed headers in ${LIB}
67
68 # Determine whether this system has symbolic links.
69 if ln -s X $LIB/ShouldNotExist 2>/dev/null; then
70   rm -f $LIB/ShouldNotExist
71   LINKS=true
72 elif ln -s X /tmp/ShouldNotExist 2>/dev/null; then
73   rm -f /tmp/ShouldNotExist
74   LINKS=true
75 else
76   LINKS=false
77 fi
78
79 echo Finding directories and links to directories
80 cd ${INPUT}
81 # Find all directories and all symlinks that point to directories.
82 # Put the list in $files.
83 # Each time we find a symlink, add it to newdirs
84 # so that we do another find within the dir the link points to.
85 # Note that $files may have duplicates in it;
86 # later parts of this file are supposed to ignore them.
87 dirs="."
88 levels=2
89 while [ -n "$dirs" ] && [ $levels -gt 0 ]
90 do
91     levels=`expr $levels - 1`
92     newdirs=
93     for d in $dirs
94     do
95         echo " Searching $INPUT/$d"
96         if [ "$d" != . ]
97         then
98             d=$d/.
99         fi
100
101         # Find all directories under $d, relative to $d, excluding $d itself.
102         files="$files `find $d -type d -print | \
103                        sed -e '/\/\.$/d' -e '/^\.$/d'`"
104         # Find all links to directories.
105         # Using `-exec test -d' in find fails on some systems,
106         # and trying to run test via sh fails on others,
107         # so this is the simplest alternative left.
108         # First find all the links, then test each one.
109         theselinks=
110         $LINKS && \
111           theselinks=`find $d -type l -print`
112         for d1 in $theselinks --dummy--
113         do
114             # If the link points to a directory,
115             # add that dir to $newdirs
116             if [ -d $d1 ]
117             then
118                 newdirs="$newdirs $d1"
119             fi
120         done
121     done
122
123     files="$files $newdirs"
124     dirs="$newdirs"
125 done
126
127 dirs=
128 echo "All directories (including links to directories):"
129 echo $files
130
131 for file in $files; do
132   rm -rf $LIB/$file
133   if [ ! -d $LIB/$file ]
134   then mkdir $LIB/$file
135   fi
136 done
137 mkdir $LIB/root
138
139 # treetops gets an alternating list
140 # of old directories to copy
141 # and the new directories to copy to.
142 treetops="${INPUT} ${LIB}"
143
144 if $LINKS; then
145   echo 'Making symbolic directory links'
146   for file in $files; do
147     dest=`ls -ld $file | sed -n 's/.*-> //p'`
148     if [ "$dest" ]; then    
149       cwd=`${PWDCMD}`
150       # In case $dest is relative, get to $file's dir first.
151       cd ${INPUT}
152       cd `echo ./$file | sed -n 's&[^/]*$&&p'`
153       # Check that the target directory exists.
154       # Redirections changed to avoid bug in sh on Ultrix.
155       (cd $dest) > /dev/null 2>&1
156       if [ $? = 0 ]; then
157         cd $dest
158         # X gets the dir that the link actually leads to.
159         x=`${PWDCMD}`
160         # If a link points to ., make a similar link to .
161         if [ $x = $INPUT ]; then
162           echo $file '->' . ': Making link'
163           rm -fr ${LIB}/$file > /dev/null 2>&1
164           ln -s . ${LIB}/$file > /dev/null 2>&1
165         # If link leads back into ${INPUT},
166         # make a similar link here.
167         elif expr $x : "${INPUT}/.*" > /dev/null; then
168           # Y gets the actual target dir name, relative to ${INPUT}.
169           y=`echo $x | sed -n "s&${INPUT}/&&p"`
170           # DOTS is the relative path from ${LIB}/$file's dir back to ${LIB}.
171           dots=`echo "$file" |
172                 sed -e 's@^./@@' -e 's@[^/][^/]*@..@g' -e 's@..$@@'`
173           echo $file '->' $dots$y ': Making link'
174           rm -fr ${LIB}/$file > /dev/null 2>&1
175           ln -s $dots$y ${LIB}/$file > /dev/null 2>&1
176         else
177           # If the link is to a dir $target outside ${INPUT},
178           # repoint the link at ${INPUT}/root$target
179           # and process $target into ${INPUT}/root$target
180           # treat this directory as if it actually contained the files.
181           echo $file '->' root$x ': Making link'
182           if [ -d $LIB/root$x ]
183           then true
184           else
185             dirname=root$x/
186             dirmade=.
187             cd $LIB
188             while [ x$dirname != x ]; do
189               component=`echo $dirname | sed -e 's|/.*$||'`
190               mkdir $component >/dev/null 2>&1
191               cd $component
192               dirmade=$dirmade/$component
193               dirname=`echo $dirname | sed -e 's|[^/]*/||'`
194             done
195           fi
196           # Duplicate directory structure created in ${LIB}/$file in new
197           # root area.
198           for file2 in $files; do
199             case $file2 in
200               $file/./*)
201                 dupdir=${LIB}/root$x/`echo $file2 | sed -n "s|^${file}/||p"`
202                 echo "Duplicating ${file}'s ${dupdir}"
203                 if [ -d ${dupdir} ]
204                 then true
205                 else
206                   mkdir ${dupdir}
207                 fi
208                 ;;
209               *)
210                 ;;
211             esac
212           done
213           # DOTS is the relative path from ${LIB}/$file's dir back to ${LIB}.
214           dots=`echo "$file" |
215                 sed -e 's@^./@@' -e 's@[^/][^/]*@..@g' -e 's@..$@@'`
216           rm -fr ${LIB}/$file > /dev/null 2>&1
217           ln -s ${dots}root$x ${LIB}/$file > /dev/null 2>&1
218           treetops="$treetops $x ${LIB}/root$x"
219         fi
220       fi
221       cd $cwd
222     fi
223   done
224 fi
225
226 set x $treetops
227 shift
228 while [ $# != 0 ]; do
229   # $1 is an old directory to copy, and $2 is the new directory to copy to.
230   cd ${INPUT}
231   cd $1
232 # The same dir can appear more than once in treetops.
233 # There's no need to scan it more than once.
234   if [ -f $2/DONE ]
235   then
236     files=
237   else
238     touch $2/DONE
239     echo Fixing directory $1 into $2
240 # Check .h files which are symlinks as well as those which are files.
241 # A link to a header file will not be processed by anything but this.
242     if $LINKS; then
243       files=`find . -name '*.h' \( -type f -o -type l \) -print`
244     else
245       files=`find . -name '*.h' -type f -print`
246     fi
247     echo Checking header files
248   fi
249 # Note that BSD43_* are used on recent MIPS systems.
250   for file in $files; do
251 # This call to egrep is essential, since checking a file with egrep
252 # is much faster than actually trying to fix it.
253 # It is also essential that most files *not* match!
254 # Thus, matching every #endif is unacceptable.
255 # But the argument to egrep must be kept small, or many versions of egrep
256 # won't be able to handle it.
257 #
258 # We use the pattern [!-.0-~] instead of [^/    ] to match a noncomment
259 # following #else or #endif because some buggy egreps think [^/] matches
260 # newline, and they thus think `#else ' matches `#e[ndiflse]*[  ]+[^/   ]'.
261 #
262 # We use the pattern [^a-zA-Z0-9_][_a-ce-km-z][a-z0-9] to match an identifier
263 # following #if or #elif that is not surrounded by __.  The `a-ce-km-z'
264 # in this pattern lacks `d' and `l'; this means we don't worry about
265 # identifiers starting with `d' or `l'.  This is OK, since none of the
266 # identifiers below start with `d' or `l'.  It also greatly improves
267 # performance, since many files contain lines of the form `#if ... defined ...'
268 # or `#if lint'.
269     if egrep '//|[      _]_IO|CTRL|^#define.NULL|^#e[nl][ds][ief]*[     ]+[!-.0-~]|^#[el]*if.*[^a-zA-Z0-9_][_a-ce-km-z][a-z0-9]' $file >/dev/null; then
270       if [ -r $file ]; then
271         cp $file $2/$file >/dev/null 2>&1       \
272         || echo "Can't copy $file"
273         chmod +w $2/$file
274         chmod a+r $2/$file
275         # Here is how the sed commands in braces work.
276         # (It doesn't work to put the comments inside the sed commands.)
277                 # Surround each word with spaces, to simplify matching below.
278                 # ANSIfy each pre-ANSI machine-dependent symbol
279                 # by surrounding it with __ __.
280                 # Remove the spaces that we inserted around each word.
281         sed -e '
282                                    :loop
283           /\\$/                 N
284           /\\$/                 b loop
285           s%^\([        ]*#[    ]*else\)[       ]*/[^*].*%\1%
286           s%^\([        ]*#[    ]*else\)[       ]*[^/   ].*%\1%
287           s%^\([        ]*#[    ]*endif\)[      ]*/[^*].*%\1%
288           s%^\([        ]*#[    ]*endif\)[      ]*\*[^/].*%\1%
289           s%^\([        ]*#[    ]*endif\)[      ]*[^/*  ].*%\1%
290           /\/\/[^*]/                    s|//\(.*\)$|/*\1*/|
291           /[    ]_IO[A-Z]*[     ]*(/    s/\(_IO[A-Z]*[  ]*(\)\(.\),/\1'\''\2'\'',/
292           /[    ]BSD43__IO[A-Z]*[       ]*(/    s/(\(.\),/('\''\1'\'',/
293           /#define._IO/                 s/'\''\([cgx]\)'\''/\1/g
294           /#define.BSD43__IO/           s/'\''\([cgx]\)'\''/\1/g
295           /[^A-Z0-9_]CTRL[      ]*(/            s/\([^'\'']\))/'\''\1'\'')/
296           /[^A-Z0-9]_CTRL[      ]*(/            s/\([^'\'']\))/'\''\1'\'')/
297           /#define[     ]*[     ]CTRL/          s/'\''\([cgx]\)'\''/\1/g
298           /#define[     ]*[     ]_CTRL/         s/'\''\([cgx]\)'\''/\1/g
299           /#define.BSD43_CTRL/          s/'\''\([cgx]\)'\''/\1/g
300           /#[el]*if/{
301                 s/[a-zA-Z0-9_][a-zA-Z0-9_]*/ & /g
302
303                 s/ bsd4\([0-9]\) / __bsd4\1__ /g
304                 s/ _*i386 / __i386__ /g
305                 s/ is68k / __is68k__ /g
306                 s/ m68k / __m68k__ /g
307                 s/ mc680\([0-9]\)0 / __mc680\10__ /g
308                 s/ news\([0-9]*\) / __news\1__ /g
309                 s/ ns32000 / __ns32000__ /g
310                 s/ pyr / __pyr__ /g
311                 s/ sony_news / __sony_news__ /g
312                 s/ sparc / __sparc__ /g
313                 s/ sun\([a-z0-9]*\) / __sun\1__ /g
314                 s/ unix / __unix__ /g
315                 s/ vax / __vax__ /g
316
317                 s/ \([a-zA-Z0-9_][a-zA-Z0-9_]*\) /\1/g
318           }
319           /^#define.NULL[       ]/      i\
320                 #undef NULL
321         ' $2/$file > $2/$file.
322         mv $2/$file. $2/$file
323         if cmp $file $2/$file >/dev/null 2>&1; then
324            rm $2/$file
325         else
326            echo Fixed $file
327         fi
328       fi
329     fi
330   done
331   shift; shift
332 done
333
334 cd ${INPUT}
335
336 # Install the proper definition of size_t in header files that it comes from.
337 for file in sys/types.h stdlib.h sys/stdtypes.h; do
338   if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
339     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
340     chmod +w ${LIB}/$file 2>/dev/null
341     chmod a+r ${LIB}/$file 2>/dev/null
342   fi
343
344   if [ -r ${LIB}/$file ]; then
345     echo Fixing $file comment
346     # Get the definition of __SIZE_TYPE__, if any.
347     # (This file must be called something.c).
348     echo "__SIZE_TYPE__" > ${LIB}/types.c
349     foo=`${GCCCMD} -E -P ${LIB}/types.c`
350     rm -f ${LIB}/types.c
351     # Default to our preferred type.
352     if [ "$foo" = __SIZE_TYPE__ ]; then foo="unsigned long int"; fi
353     sed -e "s/typedef[  a-z_]*[         ]size_t/typedef $foo size_t/" ${LIB}/$file > ${LIB}/${file}.sed
354     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
355     if cmp $file ${LIB}/$file >/dev/null 2>&1; then
356       rm ${LIB}/$file
357     fi
358   fi
359 done
360
361 # Fix one other error in this file: a mismatched quote not inside a C comment.
362 file=sundev/vuid_event.h
363 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
364   mkdir ${LIB}/sundev 2>/dev/null
365   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
366   chmod +w ${LIB}/$file 2>/dev/null
367   chmod a+r ${LIB}/$file 2>/dev/null
368 fi
369
370 if [ -r ${LIB}/$file ]; then
371   echo Fixing $file comment
372   sed -e "s/doesn't/does not/" ${LIB}/$file > ${LIB}/${file}.sed
373   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
374   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
375     rm ${LIB}/$file
376   fi
377 fi
378
379 # Fix these Sun OS files to avoid an invalid identifier in an #ifdef.
380 file=sunwindow/win_cursor.h
381 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
382 #  mkdir ${LIB}/sunwindow 2>/dev/null
383   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
384   chmod +w ${LIB}/$file 2>/dev/null
385 fi
386 if [ -r ${LIB}/$file ]; then
387   echo Fixing $file
388   sed -e "s/ecd.cursor/ecd_cursor/" ${LIB}/$file > ${LIB}/${file}.sed
389   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
390   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
391     rm ${LIB}/$file
392   fi
393 fi
394 file=sunwindow/win_lock.h
395 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
396 #  mkdir ${LIB}/sunwindow 2>/dev/null
397   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
398   chmod +w ${LIB}/$file 2>/dev/null
399 fi
400 if [ -r ${LIB}/$file ]; then
401   echo Fixing $file
402   sed -e "s/ecd.cursor/ecd_cursor/" ${LIB}/$file > ${LIB}/${file}.sed
403   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
404   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
405     rm ${LIB}/$file
406   fi
407 fi
408
409 # Fix this Sun file to avoid interfering with stddef.h.
410 file=sys/stdtypes.h
411 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
412   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
413   chmod +w ${LIB}/$file 2>/dev/null
414   chmod a+r ${LIB}/$file 2>/dev/null
415 fi
416
417 if [ -r ${LIB}/$file ]; then
418   echo Fixing $file
419 sed -e '/[       ]size_t.*;/i\
420 #ifndef _GCC_SIZE_T\
421 #define _GCC_SIZE_T' \
422     -e '/[       ]size_t.*;/a\
423 #endif' \
424     -e '/[       ]ptrdiff_t.*;/i\
425 #ifndef _GCC_PTRDIFF_T\
426 #define _GCC_PTRDIFF_T' \
427     -e '/[       ]ptrdiff_t.*;/a\
428 #endif' \
429     -e '/[       ]wchar_t.*;/i\
430 #ifndef _GCC_WCHAR_T\
431 #define _GCC_WCHAR_T' \
432     -e '/[       ]wchar_t.*;/a\
433 #endif' ${LIB}/$file > ${LIB}/${file}.sed
434   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
435   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
436     rm ${LIB}/$file
437   fi
438 fi
439
440 # Fix this file to avoid interfering with stddef.h, but don't mistakenly
441 # match e.g. ssize_t present in AIX for the ps/2.
442 file=sys/types.h
443 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
444   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
445   chmod +w ${LIB}/$file 2>/dev/null
446   chmod a+r ${LIB}/$file 2>/dev/null
447 fi
448
449 if [ -r ${LIB}/$file ]; then
450   echo Fixing $file
451 sed -e '/[      ]size_t.*;/i\
452 #ifndef _GCC_SIZE_T\
453 #define _GCC_SIZE_T' \
454     -e '/[      ]size_t.*;/a\
455 #endif' ${LIB}/$file > ${LIB}/${file}.sed
456   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
457   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
458     rm ${LIB}/$file
459   fi
460 fi
461
462 # Fix HP's use of ../machine/inline.h to refer to
463 # /usr/include/machine/inline.h
464 file=sys/spinlock.h
465 if [ ! -r ${LIB}/$file ] ; then
466   cp $file ${LIB}/$file
467 fi
468 if [ -r ${LIB}/$file ] ; then
469   echo Fixing $file
470   sed -e 's,"../machine/inline.h",<machine/inline.h>,' \
471     -e 's,"../machine/psl.h",<machine/psl.h>,' \
472   ${LIB}/$file > ${LIB}/${file}.sed
473   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
474   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
475     rm ${LIB}/$file
476   fi
477 fi
478
479 # Fix an error in this file: the #if says _cplusplus, not the double
480 # underscore __cplusplus that it should be
481 file=tinfo.h
482 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
483   mkdir ${LIB}/rpcsvc 2>/dev/null
484   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
485   chmod +w ${LIB}/$file 2>/dev/null
486   chmod a+r ${LIB}/$file 2>/dev/null
487 fi
488
489 if [ -r ${LIB}/$file ]; then
490   echo Fixing $file, __cplusplus macro
491   sed -e 's/[   ]_cplusplus/ __cplusplus/' ${LIB}/$file > ${LIB}/${file}.sed
492   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
493   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
494     rm ${LIB}/$file
495   fi
496 fi
497
498 # Fix an error in this file: a missing semi-colon at the end of the statsswtch
499 # structure definition.
500 file=rpcsvc/rstat.h
501 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
502   mkdir ${LIB}/rpcsvc 2>/dev/null
503   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
504   chmod +w ${LIB}/$file 2>/dev/null
505   chmod a+r ${LIB}/$file 2>/dev/null
506 fi
507
508 if [ -r ${LIB}/$file ]; then
509   echo Fixing $file, definition of statsswtch
510   sed -e 's/boottime$/boottime;/' ${LIB}/$file > ${LIB}/${file}.sed
511   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
512   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
513     rm ${LIB}/$file
514   fi
515 fi
516
517 # Fix an error in this file: a missing semi-colon at the end of the nodeent
518 # structure definition.
519 file=netdnet/dnetdb.h
520 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
521   mkdir ${LIB}/netdnet 2>/dev/null
522   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
523   chmod +w ${LIB}/$file 2>/dev/null
524   chmod a+r ${LIB}/$file 2>/dev/null
525 fi
526
527 if [ -r ${LIB}/$file ]; then
528   echo Fixing $file, definition of nodeent
529   sed -e 's/char.*na_addr *$/char *na_addr;/' ${LIB}/$file > ${LIB}/${file}.sed
530   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
531   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
532     rm ${LIB}/$file
533   fi
534 fi
535
536 # Check for bad #ifdef line (in Ultrix 4.1)
537 file=sys/file.h
538 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
539   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
540   chmod +w ${LIB}/$file 2>/dev/null
541   chmod a+r ${LIB}/$file 2>/dev/null
542 fi
543
544 if [ -r ${LIB}/$file ]; then
545   echo Fixing $file, bad \#ifdef line
546   sed -e 's/#ifdef KERNEL/#if defined(KERNEL)/' ${LIB}/$file > ${LIB}/${file}.sed
547   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
548   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
549     rm ${LIB}/$file
550   fi
551 fi
552
553 # Check for superfluous `static' (in Ultrix 4.2)
554 file=machine/cpu.h
555 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
556   mkdir ${LIB}/machine 2>/dev/null
557   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
558   chmod +w ${LIB}/$file 2>/dev/null
559   chmod a+r ${LIB}/$file 2>/dev/null
560 fi
561
562 if [ -r ${LIB}/$file ]; then
563   echo Fixing $file, superfluous static
564   sed -e 's/^static struct tlb_pid_state/struct tlb_pid_state/' ${LIB}/$file > ${LIB}/${file}.sed
565   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
566   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
567     rm ${LIB}/$file
568   else
569 # This file has an alternative name, mips/cpu.h.  Fix that name, too.
570     if cmp machine/cpu.h mips/cpu.h > /dev/null 2>&1; then
571       mkdir ${LIB}/mips 2>&-
572       ln ${LIB}/$file ${LIB}/mips/cpu.h 
573     fi
574   fi
575 fi
576
577 # Incorrect sprintf declaration in X11/Xmu.h
578 file=X11/Xmu.h
579 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
580   mkdir ${LIB}/X11 2>/dev/null
581   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
582   chmod +w ${LIB}/$file 2>/dev/null
583   chmod a+r ${LIB}/$file 2>/dev/null
584 fi
585
586 if [ -r ${LIB}/$file ]; then
587   echo Fixing $file sprintf declaration
588   sed -e 's,^extern char \*     sprintf();$,#ifndef __STDC__\
589 extern char *   sprintf();\
590 #endif /* !defined __STDC__ */,' ${LIB}/$file > ${LIB}/${file}.sed
591   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
592   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
593     rm ${LIB}/$file
594   fi
595 fi
596
597 # Incorrect sprintf declaration in X11/Xmu/Xmu.h
598 # (It's not clear whether the right file name is this or X11/Xmu.h.)
599 file=X11/Xmu/Xmu.h
600 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
601   mkdir ${LIB}/X11/Xmu 2>/dev/null
602   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
603   chmod +w ${LIB}/$file 2>/dev/null
604   chmod a+r ${LIB}/$file 2>/dev/null
605 fi
606
607 if [ -r ${LIB}/$file ]; then
608   echo Fixing $file sprintf declaration
609   sed -e 's,^extern char \*     sprintf();$,#ifndef __STDC__\
610 extern char *   sprintf();\
611 #endif /* !defined __STDC__ */,' ${LIB}/$file > ${LIB}/${file}.sed
612   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
613   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
614     rm ${LIB}/$file
615   fi
616 fi
617
618 # Check for missing ';' in struct
619 file=netinet/ip.h
620 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
621   mkdir ${LIB}/netinet 2>/dev/null
622   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
623   chmod +w ${LIB}/$file 2>/dev/null
624   chmod a+r ${LIB}/$file 2>/dev/null
625 fi
626
627 if [ -r ${LIB}/$file ]; then
628   echo Fixing $file
629   sed -e '/^struct/,/^};/s/}$/};/' ${LIB}/$file > ${LIB}/${file}.sed
630   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
631   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
632     rm -f ${LIB}/$file
633   fi
634 fi
635
636 # Fix the CAT macro in SunOS memvar.h.
637 file=pixrect/memvar.h
638 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
639   mkdir ${LIB}/pixrect 2>/dev/null
640   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
641   chmod +w ${LIB}/$file 2>/dev/null
642   chmod a+r ${LIB}/$file 2>/dev/null
643 fi
644
645 if [ -r ${LIB}/$file ]; then
646   echo Fixing $file
647   sed -e '/^#define.CAT(a,b)/ i\
648 #ifdef __STDC__ \
649 #define CAT(a,b) a##b\
650 #else
651 /^#define.CAT(a,b)/ a\
652 #endif
653 ' ${LIB}/$file > ${LIB}/${file}.sed
654   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
655   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
656     rm -f ${LIB}/$file
657   fi
658 fi
659
660 # Check for yet more missing ';' in struct (in SunOS 4.0.x)
661 file=rpcsvc/rusers.h
662 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
663   mkdir ${LIB}/rpcsvc 2>/dev/null
664   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
665   chmod +w ${LIB}/$file 2>/dev/null
666   chmod a+r ${LIB}/$file 2>/dev/null
667 fi
668
669 if [ -r ${LIB}/$file ]; then
670   echo Fixing $file
671   sed -e '/^struct/,/^};/s/_cnt$/_cnt;/' ${LIB}/$file > ${LIB}/${file}.sed
672   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
673   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
674     rm -f ${LIB}/$file
675   fi
676 fi
677
678 # Fix return type of exit and abort in <stdlib.h> on SunOS 4.1.
679 # Also wrap protection around size_t for m88k-sysv3 systems.
680 file=stdlib.h
681 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
682   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
683   chmod +w ${LIB}/$file 2>/dev/null
684   chmod a+r ${LIB}/$file 2>/dev/null
685 fi
686
687 if [ -r ${LIB}/$file ]; then
688   echo Fixing $file
689   sed -e 's/int abort/void      abort/g' \
690   -e 's/int     free/void       free/g' \
691   -e 's/char \* calloc/void \*  calloc/g' \
692   -e 's/char \* malloc/void \*  malloc/g' \
693   -e 's/char \* realloc/void \* realloc/g' \
694   -e 's/int     exit/void       exit/g' \
695   -e '/typedef[         a-zA-Z_]*[      ]size_t[        ]*;/i\
696 #ifndef _GCC_SIZE_T\
697 #define _GCC_SIZE_T' \
698   -e '/typedef[         a-zA-Z_]*[      ]size_t[        ]*;/a\
699 #endif' \
700       ${LIB}/$file > ${LIB}/${file}.sed
701   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
702   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
703     rm -f ${LIB}/$file
704   fi
705 fi
706
707 # Fix return type of free and {c,m,re}alloc in <malloc.h> on SunOS 4.1.
708 file=malloc.h
709 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
710   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
711   chmod +w ${LIB}/$file 2>/dev/null
712   chmod a+r ${LIB}/$file 2>/dev/null
713 fi
714
715 if [ -r ${LIB}/$file ]; then
716   echo Fixing $file
717   sed -e 's/typedef[    ]char \*        malloc_t/typedef void \*        malloc_t/g' \
718   -e 's/int[    ][      ]*free/void     free/g' \
719   ${LIB}/$file > ${LIB}/${file}.sed
720   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
721   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
722     rm -f ${LIB}/$file
723   fi
724 fi
725
726 # Fix bogus #ifdef in <hsfs/hsfs_spec.h> on SunOS 4.1.
727 file=hsfs/hsfs_spec.h
728 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
729   mkdir ${LIB}/hsfs 2>/dev/null
730   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
731   chmod +w ${LIB}/$file 2>/dev/null
732   chmod a+r ${LIB}/$file 2>/dev/null
733 fi
734
735 if [ -r ${LIB}/$file ]; then
736   echo Fixing $file
737   sed -e 's/\#ifdef __i386__ || __vax__/\#if __i386__ || __vax__/g' \
738     ${LIB}/$file > ${LIB}/${file}.
739   rm -f ${LIB}/$file; mv ${LIB}/${file}. ${LIB}/$file
740   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
741     rm -f ${LIB}/$file
742   fi
743 fi
744
745 # Fix bogus #ifdef in <hsfs/hsnode.h> on SunOS 4.1.
746 file=hsfs/hsnode.h
747 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
748   mkdir ${LIB}/hsfs 2>/dev/null
749   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
750   chmod +w ${LIB}/$file 2>/dev/null
751   chmod a+r ${LIB}/$file 2>/dev/null
752 fi
753
754 if [ -r ${LIB}/$file ]; then
755   echo Fixing $file
756   sed -e 's/\#ifdef __i386__ || __sun4c__/\#if __i386__ || __sun4c__/g' \
757     ${LIB}/$file > ${LIB}/${file}.sed
758   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
759   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
760     rm -f ${LIB}/$file
761   fi
762 fi
763
764 # Fix bogus #ifdef in <hsfs/iso_spec.h> on SunOS 4.1.
765 file=hsfs/iso_spec.h
766 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
767   mkdir ${LIB}/hsfs 2>/dev/null
768   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
769   chmod +w ${LIB}/$file 2>/dev/null
770   chmod a+r ${LIB}/$file 2>/dev/null
771 fi
772
773 if [ -r ${LIB}/$file ]; then
774   echo Fixing $file
775   sed -e 's/\#ifdef __i386__ || __vax__/\#if __i386__ || __vax__/g' \
776     ${LIB}/$file > ${LIB}/${file}.sed
777   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
778   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
779     rm -f ${LIB}/$file
780   fi
781 fi
782
783 # Incorrect #include in Sony News-OS 3.2.
784 file=machine/machparam.h
785 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
786   mkdir ${LIB}/machine 2>/dev/null
787   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
788   chmod +w ${LIB}/$file 2>/dev/null
789   chmod a+r ${LIB}/$file 2>/dev/null
790 fi
791
792 if [ -r ${LIB}/$file ]; then
793   echo Fixing $file, incorrect \#include
794   sed -e 's@"../machine/endian.h"@<machine/endian.h>@' \
795     ${LIB}/$file > ${LIB}/${file}.
796   rm -f ${LIB}/$file; mv ${LIB}/${file}. ${LIB}/$file
797   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
798     rm -f ${LIB}/$file
799   fi
800 fi
801
802 # Multiline comment after typedef on IRIX 4.0.1.
803 file=sys/types.h
804 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
805   mkdir ${LIB}/sys 2>/dev/null
806   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
807   chmod +w ${LIB}/$file 2>/dev/null
808   chmod a+r ${LIB}/$file 2>/dev/null
809 fi
810
811 if [ -r ${LIB}/$file ]; then
812   echo Fixing $file, comment in the middle of \#ifdef
813   sed -e 's@type of the result@type of the result */@' \
814     -e 's@of the sizeof@/* of the sizeof@' \
815     ${LIB}/$file > ${LIB}/${file}.sed
816   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
817   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
818     rm -f ${LIB}/$file
819   fi
820 fi
821
822 # Turning // comments into /* */ comments trashes this IRIX 4.0.1
823 # header file, which embeds // comments inside multi-line /* */
824 # comments.  If this looks like the IRIX header file, we refix it by
825 # just throwing away the // comments.
826 file=fam.h
827 if [ -r ${LIB}/$file ]; then
828   if egrep indigo.esd ${LIB}/$file > /dev/null; then
829     echo Fixing $file, overeager sed script
830     rm ${LIB}/$file
831     sed -e 's|//.*$||g' $file > ${LIB}/$file
832     chmod +w ${LIB}/$file 2>/dev/null
833     chmod a+r ${LIB}/$file 2>/dev/null
834   fi
835 fi
836
837 # Another IRIX 4.0.1 header file contains the string "//"
838 file=elf_abi.h
839 if [ -r ${LIB}/$file ]; then
840   echo Fixing $file, overeager sed script
841   sed -e 's|"/\*"\*/|"//"|' ${LIB}/$file > ${LIB}/${file}.sed
842   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
843   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
844     rm -f ${LIB}/$file
845   fi
846 fi
847
848 # Same problem with a file from SunOS 4.1.3 : a header file containing
849 # the string "//" embedded in "/**/"
850 file=sbusdev/audiovar.h
851 if [ -r ${LIB}/$file ]; then
852   echo Fixing $file, overeager sed script
853   rm ${LIB}/$file
854   sed -e 's|//.*$||g' $file > ${LIB}/$file
855   chmod +w ${LIB}/$file 2>/dev/null
856   chmod a+r ${LIB}/$file 2>/dev/null
857 fi
858
859 # Fix non-ANSI memcpy declaration that conflicts with gcc's builtin
860 # declaration on Sun OS 4.x.  We must only fix this on Sun OS 4.x, because
861 # many other systems have similar text but correct versions of the file.
862 # To ensure only Sun's is fixed, we grep for a likely unique string.
863 file=memory.h
864 if [ -r $file ] && egrep '/\*   @\(#\)memory\.h 1\.[2-4] 8./../.. SMI; from S5R2 1\.2   \*/' $file > /dev/null; then
865   if [ ! -r ${LIB}/$file ]; then
866     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
867     chmod +w ${LIB}/$file 2>/dev/null
868     chmod a+r ${LIB}/$file 2>/dev/null
869   fi
870   if [ -r ${LIB}/$file ]; then
871     echo Replacing $file
872     cat > ${LIB}/$file << EOF
873 /* This file was generated by fixincludes */
874 #ifndef __memory_h__
875 #define __memory_h__
876
877 #ifdef __STDC__
878 extern void *memccpy();
879 extern void *memchr();
880 extern void *memcpy();
881 extern void *memset();
882 #else
883 extern char *memccpy();
884 extern char *memchr();
885 extern char *memcpy();
886 extern char *memset();
887 #endif /* __STDC__ */
888
889 extern int memcmp();
890
891 #endif /* __memory_h__ */
892 EOF
893   fi
894 fi
895
896 # parameters not const on DECstation Ultrix V4.0.
897 file=stdio.h
898 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
899   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
900   chmod +w ${LIB}/$file 2>/dev/null
901   chmod a+r ${LIB}/$file 2>/dev/null
902 fi
903
904 if [ -r ${LIB}/$file ]; then
905   echo Fixing $file, non-const arg
906   sed -e 's@perror( char \*__s );@perror( const char *__s );@' \
907       -e 's@fputs( char \*__s,@fputs( const char *__s,@' \
908       -e 's@fopen( char \*__filename, char \*__type );@fopen( const char *__filename, const char *__type );@' \
909       -e 's@fwrite( void \*__ptr,@fwrite( const void *__ptr,@' \
910       -e 's@fscanf( FILE \*__stream, char \*__format,@fscanf( FILE *__stream, const char *__format,@' \
911       -e 's@scanf( char \*__format,@scanf( const char *__format,@' \
912       -e 's@sscanf( char \*__s, char \*__format,@sscanf( const char *__s, const char *__format,@' \
913     ${LIB}/$file > ${LIB}/${file}.sed
914   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
915   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
916     rm -f ${LIB}/$file
917   fi
918 fi
919
920 # parameters conflict with C++ new on rs/6000 
921 for file in stdio.h unistd.h ; do
922   if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
923     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
924     chmod +w ${LIB}/$file 2>/dev/null
925   fi
926
927   if [ -r ${LIB}/$file ]; then
928     echo Fixing $file, parameter name conflicts
929     sed -e 's@rename(const char \*old, const char \*new)@rename(const char *_old, const char *_new)@' \
930       ${LIB}/$file > ${LIB}/${file}.sed
931     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
932     if cmp $file ${LIB}/$file >/dev/null 2>&1; then
933       rm -f ${LIB}/$file
934     fi
935   fi
936 done
937
938 # function class(double x) conflicts with C++ keyword on rs/6000 
939 file=math.h
940 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
941   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
942   chmod +w ${LIB}/$file 2>/dev/null
943   chmod a+r ${LIB}/$file 2>/dev/null
944 fi
945
946 if [ -r ${LIB}/$file ]; then
947   if grep 'class[(]' ${LIB}/$file >/dev/null; then
948     echo Fixing $file
949     sed -e '/class[(]/i\
950 #ifndef __cplusplus' \
951         -e '/class[(]/a\
952 #endif' ${LIB}/$file > ${LIB}/${file}.sed
953     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
954     if cmp $file ${LIB}/$file >/dev/null 2>&1; then
955       rm ${LIB}/$file
956     fi
957   fi
958 fi
959
960 # NeXT defines 'int wait(union wait*)', which conflicts with Posix.1.
961 file=sys/wait.h
962 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
963   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
964   chmod +w ${LIB}/$file 2>/dev/null
965 fi
966
967 if [ -r ${LIB}/$file ] \
968   && grep 'wait[(]union wait' ${LIB}/$file >/dev/null; then
969   echo Fixing $file, bad wait formal
970   sed -e 's@wait(union wait@wait(void@' ${LIB}/$file > ${LIB}/${file}.sed
971   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
972   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
973     rm -f ${LIB}/$file
974   fi
975 fi
976
977 # Don't use or define the name va_list in stdio.h.
978 # This is for ANSI and also to interoperate properly with gvarargs.h.
979 file=stdio.h
980 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
981   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
982   chmod +w ${LIB}/$file 2>/dev/null
983   chmod a+r ${LIB}/$file 2>/dev/null
984 fi
985
986 if [ -r ${LIB}/$file ]; then
987   echo Fixing $file, use of va_list
988   # Arrange for stdio.h to use stdarg.h to define __gnuc_va_list
989   (echo "#define __need___va_list"
990    echo "#include <stdarg.h>") > ${LIB}/${file}.sed
991   # Use __gnuc_va_list in arg types in place of va_list.
992   # On 386BSD use __gnuc_va_list instead of _VA_LIST_. We're hoping the
993   # trailing parentheses and semicolon save all other systems from this.
994   # Define __va_list__ (something harmless and unused) instead of va_list.
995   # Don't claim to have defined va_list.
996   sed -e 's@ va_list @ __gnuc_va_list @' \
997       -e 's@ va_list)@ __gnuc_va_list)@' \
998       -e 's@ _VA_LIST_));@ __gnuc_va_list));@' \
999       -e 's@ va_list@ __va_list__@' \
1000       -e 's@\*va_list@*__va_list__@' \
1001       -e 's@_NEED___VA_LIST@_NEED___Va_LIST@' \
1002       -e 's@VA_LIST@DUMMY_VA_LIST@' \
1003       -e 's@_NEED___Va_LIST@_NEED___VA_LIST@' \
1004     ${LIB}/$file >> ${LIB}/${file}.sed
1005   
1006   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1007   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1008     rm -f ${LIB}/$file
1009   fi
1010 fi
1011
1012 # Cancel out ansi_compat.h on Ultrix.  Replace it with empty file.
1013 file=ansi_compat.h
1014 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1015   if grep -s ULTRIX $file; then
1016     echo "/* This file intentionally left blank.  */" > $LIB/$file
1017   fi
1018 fi
1019
1020 # parameter to atof not const on DECstation Ultrix V4.0.
1021 # also get rid of bogus inline definitions in HP-UX 8.0
1022 file=math.h
1023 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1024   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1025   chmod +w ${LIB}/$file 2>/dev/null
1026   chmod a+r ${LIB}/$file 2>/dev/null
1027 fi
1028
1029 if [ -r ${LIB}/$file ]; then
1030   echo Fixing $file, non-const arg
1031   sed -e 's@atof( char \*__nptr );@atof( const char *__nptr );@' \
1032       -e 's@inline int abs(int d) { return (d>0)?d:-d; }@@' \
1033       -e 's@inline double abs(double d) { return fabs(d); }@@' \
1034     ${LIB}/$file > ${LIB}/${file}.sed
1035   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1036   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1037     rm -f ${LIB}/$file
1038   fi
1039 fi
1040
1041 # In limits.h, put #ifndefs around things that are supposed to be defined
1042 # in float.h to avoid redefinition errors if float.h is included first.
1043 # On HP/UX this patch does not work, because on HP/UX limits.h uses
1044 # multi line comments and the inserted #endif winds up inside the
1045 # comment.  Fortunately, HP/UX already uses #ifndefs in limits.h; if
1046 # we find a #ifndef FLT_MIN we assume that all the required #ifndefs
1047 # are there, and we do not add them ourselves.
1048 file=limits.h
1049 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1050   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1051   chmod +w ${LIB}/$file 2>/dev/null
1052   chmod a+r ${LIB}/$file 2>/dev/null
1053 fi
1054
1055 if [ -r ${LIB}/$file ]; then
1056   if egrep 'ifndef[     ]+FLT_MIN' ${LIB}/$file >/dev/null; then
1057     true
1058   else
1059     echo Fixing $file
1060     sed -e '/[  ]FLT_MIN[       ]/i\
1061 #ifndef FLT_MIN'\
1062         -e '/[  ]FLT_MIN[       ]/a\
1063 #endif'\
1064         -e '/[  ]FLT_MAX[       ]/i\
1065 #ifndef FLT_MAX'\
1066         -e '/[  ]FLT_MAX[       ]/a\
1067 #endif'\
1068         -e '/[  ]FLT_DIG[       ]/i\
1069 #ifndef FLT_DIG'\
1070         -e '/[  ]FLT_DIG[       ]/a\
1071 #endif'\
1072         -e '/[  ]DBL_MIN[       ]/i\
1073 #ifndef DBL_MIN'\
1074         -e '/[  ]DBL_MIN[       ]/a\
1075 #endif'\
1076         -e '/[  ]DBL_MAX[       ]/i\
1077 #ifndef DBL_MAX'\
1078         -e '/[  ]DBL_MAX[       ]/a\
1079 #endif'\
1080         -e '/[  ]DBL_DIG[       ]/i\
1081 #ifndef DBL_DIG'\
1082         -e '/[  ]DBL_DIG[       ]/a\
1083 #endif'\
1084       ${LIB}/$file > ${LIB}/${file}.sed
1085     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1086   fi
1087   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1088     echo Deleting ${LIB}/$file\; no fixes were needed.
1089     rm -f ${LIB}/$file
1090   fi
1091 fi
1092
1093 # In math.h, put #ifndefs around things that might be defined in a gcc
1094 # specific math-*.h file.
1095 file=math.h
1096 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1097   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1098   chmod +w ${LIB}/$file 2>/dev/null
1099   chmod a+r ${LIB}/$file 2>/dev/null
1100 fi
1101
1102 if [ -r ${LIB}/$file ]; then
1103   echo Fixing $file
1104   sed -e '/define[      ]HUGE_VAL[      ]/i\
1105 #ifndef HUGE_VAL'\
1106       -e '/define[      ]HUGE_VAL[      ]/a\
1107 #endif'\
1108     ${LIB}/$file > ${LIB}/${file}.sed
1109   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1110   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1111     echo Deleting ${LIB}/$file\; no fixes were needed.
1112     rm -f ${LIB}/$file
1113   fi
1114 fi
1115
1116 # These two files on SunOS 4 are included by other files
1117 # in the same directory, using "...".  So we must make sure they exist
1118 # in the same directory as the other fixed files.
1119 if [ -r ${INPUT}/multimedia/audio_errno.h ]
1120 then
1121   ln -s ${INPUT}/multimedia/audio_errno.h ${LIB}/multimedia 2>/dev/null
1122 fi
1123 if [ -r ${INPUT}/multimedia/audio_hdr.h ]
1124 then
1125   ln -s ${INPUT}/multimedia/audio_hdr.h ${LIB}/multimedia 2>/dev/null
1126 fi
1127
1128 # Determine if we're on Interactive Unix 2.2 or later, in which case we
1129 # need to fix some additional files.  This is the same test for ISC that
1130 # Autoconf uses.
1131 if test -d /etc/conf/kconfig.d \
1132     && grep _POSIX_VERSION /usr/include/sys/unistd.h >/dev/null 2>&1; then
1133   echo "Fixing ISC __STDC__ goof in several files..."
1134   for name in stdio.h math.h ctype.h sys/limits.h sys/fcntl.h sys/dirent.h; do
1135     echo $name
1136     if test -r ${LIB}/$name; then
1137       file=${LIB}/$name
1138     else
1139       file=${INPUT}/$name
1140     fi
1141     # On Interactive 2.2, certain traditional Unix definitions
1142     # (notably getc and putc in stdio.h) are omitted if __STDC__ is
1143     # defined, not just if _POSIX_SOURCE is defined.  This makes it
1144     # impossible to compile any nontrivial program except with -posix.
1145     sed \
1146 's/!defined(__STDC__) && !defined(_POSIX_SOURCE)/!defined(_POSIX_SOURCE)/' \
1147             < $file > ${LIB}/$name.
1148     mv ${LIB}/$name. ${LIB}/$name
1149   done
1150   
1151   echo "Fixing ISC fmod declaration"
1152   # This one's already been fixed for other things.
1153   file=${LIB}/math.h
1154   sed 's/fmod(double)/fmod(double, double)/' <$file >$file.
1155   mv $file. $file
1156   
1157   echo "Fixing nested comments in ISC <sys/limits.h>"
1158   file=sys/limits.h
1159   sed '/CHILD_MAX/s,/\* Max, Max,' < ${INPUT}/$file >${LIB}/$file.
1160   sed '/OPEN_MAX/s,/\* Max, Max,' < ${LIB}/$file. >${LIB}/$file
1161 fi
1162
1163 # These files in Sun OS 4.x use /**/ to concatenate tokens.
1164 for file in sparc/asm_linkage.h sun3/asm_linkage.h sun3x/asm_linkage.h  \
1165         sun4/asm_linkage.h sun4c/asm_linkage.h sun4m/asm_linkage.h      \
1166         sun4c/debug/asm_linkage.h sun4m/debug/asm_linkage.h;
1167 do
1168   if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1169     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1170     chmod +w ${LIB}/$file 2>/dev/null
1171     chmod a+r ${LIB}/$file 2>/dev/null
1172   fi
1173
1174   if [ -r ${LIB}/$file ]; then
1175     sed -e 's|/\*\*/|##|g' ${LIB}/$file > ${LIB}/${file}.sed
1176     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1177     if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1178       rm -f ${LIB}/$file
1179     fi
1180   fi
1181 done
1182
1183 echo 'Removing unneeded directories:'
1184 cd $LIB
1185 files=`find . -type d -print | sort -r`
1186 for file in $files; do
1187   rmdir $LIB/$file > /dev/null 2>&1
1188 done
1189
1190 if $LINKS; then
1191   echo 'Making internal symbolic non-directory links'
1192   cd ${INPUT}
1193   files=`find . -type l -print`
1194   for file in $files; do
1195     dest=`ls -ld $file | sed -n 's/.*-> //p'`
1196     if expr "$dest" : '[^/].*' > /dev/null; then    
1197       target=${LIB}/`echo file | sed "s|[^/]*\$|$dest|"`
1198       if [ -f $target ]; then
1199         ln -s $dest ${LIB}/$file >/dev/null 2>&1
1200       fi
1201     fi
1202   done
1203 fi
1204
1205 echo 'Cleaning up DONE files.'
1206 cd $LIB
1207 find . -name DONE -exec rm -f {} ';'
1208
1209 exit 0